<template>
  <div :class="{'input-focused': focused, 'show-label': valueNotEmpty, 'invalid': requiredStatus && touched || invalid, 'readonly': readonly}">
    <label :for="id" class="base-label">
      {{ label }}
    </label>
    <div
      class='base-input-wrapper'
    >
      <input
        :id="id"
        class="base-input"
        v-bind="$attrs"
        :placeholder="$attrs.placeholder"
        :value="value"
        :readonly='readonly'
        @focus="focusHandler"
        @input="inputHandler"
        @blur="blurHandler"
      >
      <p v-show='requiredStatus && touched || invalid' class='invalid-text'>Required field</p>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    value: {
      type: String,
      default: ''
    },

    id: {
      type: String,
      default: ''
    },

    label: {
      type: String,
      default: ''
    },

    invalid: {
      type: Boolean,
      default: false
    },

    requiredField: {
      type: Boolean,
      default: false
    },

    readonly: {
      type: Boolean,
      default: false
    }

  },

  data() {
    return {
      focused: false,
      touched: false
    }
  },

  computed: {
    valueNotEmpty() {
      return this.value.length > 0
    },
    requiredStatus(){
      if(this.requiredField) {
        return  this.value.length === 0
      }
      return false
    }
  },

  methods: {
    inputHandler(event) {
      // eslint-disable-next-line vue/no-mutating-props
      this.$emit('input', event.target.value)
    },

    focusHandler() {
      this.focused = true
    },

    blurHandler() {
      this.touched = true
      this.focused = false
    }
  }
}
</script>

<style lang='scss' scoped>

.base-input-wrapper {
  border-bottom: 2px solid #3A4675;
  width: 100%;
  padding: 18px 0 18px;
  transition: all 0.5s;
  position: relative;
}

.base-input {
  width: 100%;
  height: 25px;
  margin: 0;
  border: none;
  outline: none;
  padding: 0;
  background: transparent;
  font-size: 20px;
  color: #FFFFFF;

  @media (max-width: 767px) {
    font-size: 18px;
  }
}

.base-input::placeholder ,{
  color: rgba(255, 255, 255, 0.45);
  font-size: 20px;
  font-weight: 300;

  @media (max-width: 767px) {
    font-size: 18px;
  }
}

label {
  font-weight: 300;
  font-size: 16px;
  color: rgba(255, 255, 255, 0.45);
  opacity: 0;
  transition: all 0.5s;
}

.show-label {
  label {
    opacity: 1;
  }
}

.input-focused {
  .base-input-wrapper {
    border-bottom: 2px solid #438AF9;
  }

  label {
    color: #438AF9;
  }
}

.invalid {
  .base-input-wrapper {
    border-bottom: 2px solid #FA5D2C;
  }

  label {
    color: #FA5D2C;
  }
}

.invalid-text {
  color: #FA5D2C;
  position: absolute;
  bottom: 48px;
  left: 0;
  font-size: 14px;
}


.readonly {
  pointer-events: none;
  opacity: 0.5;
}
</style>
